EDIT - feature request #9541

Improve referencing objects handling
03/19/2021 09:02 PM - Andreas Mdller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.22

Severity: normal

Description

¢ DescriptionElementSource, SecundumSource and NomenclaturalStatus do now have a backlink to their referencing main
object. Better labels and "open in" can be created for them, so.

¢ performance should be improved, currently sorting is done on "description" therefore each label needs to be created during sort,
which is at least 1 lazy-initialization call per record if initialization is needed

¢ setting module parameters like "referencingObjectsList” is not done synchronized and within 1 command line with a server call.
This may result in incorrect data if >1 job is running

¢ the total number of records found should be shown

¢ each job should be cancelable as often as possible so the jobs should be done in small parts, this is important for human
triggered cancel as well as cancel due to focus change

e tbc
Related issues:
Related to EDIT - task #9999: Improve formatting for referencing objects of d... Closed 03/24/2022 03/29/2022
Related to EDIT - bug #9988: Fix selection for supplemental data view/referen... New
Related to EDIT - bug #9656: Closing the referencing objects view should canc... New
Related to EDIT - feature request #8305: show number of references in referen... New
Related to EDIT - bug #8261: Referencing objects view is missing focus after ... New
Related to EDIT - bug #8126: Mediarepresentations should not be shown in Refe... New
Related to EDIT - feature request #6697: reconstruct getReferencingObjects t... Worksforme
Related to EDIT - bug #6476: Remove MediaRepresentation and MediaRepresentati... New
Related to EDIT - feature request #6460: Refactor referencing objects in a wa... Closed
Related to EDIT - feature request #2584: Show loading information for "Refere... Worksforme
Related to EDIT - bug #10051: Remaining issues for Referencing Objects View New

Associated revisions

Revision 844e6554 - 03/19/2021 09:07 PM - Andreas Miiller

ref #9541 improve handling for description main objects

Revision b01e3f90 - 03/19/2021 09:07 PM - Andreas Miiller
ref #9541 utitlity method for KeyStatement

Revision 16922c6f - 03/31/2021 09:28 PM - Andreas Miiller

ref #9541 move distance formatting to own formatting class

Revision 8b7fdba9 - 03/31/2021 09:58 PM - Andreas Miiller

ref #9541 DTOs for referencing objects and server side initialization

Revision dcef45f2 - 03/31/2021 10:35 PM - Andreas Muiller
ref #9541 deproxy target entity and referencing entity

Revision 99de1ab2 - 04/01/2021 12:46 AM - Andreas Miiller

ref #9541 further improve referencing object handling
Revision 58e6¢bh8f - 04/01/2021 01:05 AM - Andreas Miiller

ref #9541 new referencing objects implementation in TaxEditor

Revision 7d58503b - 04/01/2021 01:28 AM - Andreas Miiller

ref #9541 adapt bulk editor opener for referencing objects

Revision a6dcfe44 - 04/01/2021 01:55 AM - Andreas Miiller

ref #9541 Source for => for

Revision 18bd5760 - 04/01/2021 03:06 AM - Andreas Miiller

ref #9541 fix query on IdentifiableSource and SingleSource

Revision 69dc5be6 - 04/01/2021 03:32 AM - Andreas Miiller

ref #9541 open referencing objects in openln target

Revision 824ea259 - 04/01/2021 10:56 AM - Andreas Miiller

ref #9541 fix missing Openln menu for ordinary CdmBase input

Revision fd6c6dec - 04/01/2021 10:59 AM - Andreas Miiller
ref #9541 use openinTarget for Openin (CdmViewerUtilE4)

Revision 2ac111f5 - 04/02/2021 12:08 AM - Andreas Miiller
ref #9541 add getBestOpenInTargetType to ReferencingObjectDto

Revision 8805390 - 04/02/2021 12:16 AM - Andreas Miiller

ref #9541 refactor Open..Handlers to all use UuidAndTitleCache as input and some more changes and bugfixes

Revision 1f0bb7e2 - 04/02/2021 01:44 AM - Andreas Miiller
ref #9541 g&d add target description for untargeted sources

Revision 771e2ffd - 04/02/2021 06:21 PM - Andreas Muiller
ref #9541 fix potential NPE in distributionDto loading

Revision ca839fe0 - 04/02/2021 08:19 PM - Andreas Miiller

ref #9541 improve label for taxon nodes in ReferencingObjectFormatter

Revision 3ce2af15 - 04/02/2021 09:52 PM - Andreas Miiller

ref #9541 further fixes for referencing objects and related issues

Revision bfb8b043 - 04/20/2021 04:16 PM - Andreas Miiller
fix NPE and handle not existing targetEntity

History

#1 - 03/31/2021 02:04 PM - Andreas Miiller

- Subject changed from Improve labels for referencing objects to Improve referencing objects handling

#2 - 03/31/2021 02:11 PM - Andreas Miller
- Description updated

- % Done changed from 0 to 20

#3 - 04/16/2021 09:49 PM - Andreas Miiller

- Status changed from New to Resolved

#4 - 04/20/2021 05:05 PM - Andreas Miiller

- Description updated
What | did:

e moved all referencing objects formatting to cdmlib (ReferencingObjectFormatter) to allow server side formatting and to have formatting at one

place (model.format), this is a bit critical because referencing objects formatting is somehow context depending
refactored the ReferencingObjectsViewE4 to
o first load objects without description and without link to target entity
o load descriptions and target entity in bulk
o correct handling of synchronized variables (using synchronized and volatile)
o use only 1 variable (actualUuid) to check if the focus is on a new entity, this variable is synchronized
o implement "cancel" during bulk load of descriptions and and target entity
e refactor "open in" framework to be more generic for the different types of entities having the focus (model instances, DTOs, others, ...)
allow self referening "Open in ... referencing objects view" to traverse the object graph
some more that | forgot

#5 - 04/20/2021 05:12 PM - Andreas Miiller

open issues might be:

e improved formatting for all CdmBase classes (some formatting also seems to have regression, e.g. Distributions)

¢ self-referencing "open in" should not work on target but on base entity to really traverse the graph and not jump to the target instance (e.g. jump

from DescriptionElementSource reference to the source and not immediately to the taxon itself)
improve handling of view label and count
e formatting and target object computation without initializing model objects

is only using the name as original spelling)

#6 - 04/20/2021 05:14 PM - Andreas Miiller
- Assignee changed from Andreas Mtiller to Katja Luther

- % Done changed from 20 to 50

Can you please review?

Open issues should be moved to new ticket.

#7 - 03/24/2022 01:38 PM - Andreas Miuller

- Related to task #9999: Improve formatting for referencing objects of descriptive data added

#8 - 03/24/2022 02:38 PM - Andreas Miuller

- Related to bug #9988: Fix selection for supplemental data view/referencing objects view added

#9 - 03/24/2022 02:40 PM - Andreas Miuller

- Related to bug #9656: Closing the referencing objects view should cancel the current request added

#10 - 03/24/2022 02:41 PM - Andreas Miiller

- Related to feature request #8305: show number of references in referencing objects view added

#11 - 03/24/2022 02:41 PM - Andreas Miiller

- Related to bug #8261: Referencing objects view is missing focus after opening added

#12 - 03/24/2022 02:41 PM - Andreas Miiller

- Related to bug #8126: Mediarepresentations should not be shown in Referencing objects view added

#13 - 03/24/2022 02:43 PM - Andreas Miiller

- Related to feature request #6697: reconstruct getReferencingObjects to return DTOs added

#14 - 03/24/2022 02:44 PM - Andreas Miiller

- Related to bug #6476: Remove MediaRepresentation and MediaRepresentationPart from Referencing objects view added

#15 - 03/24/2022 02:44 PM - Andreas Miiller

- Related to feature request #6460: Refactor referencing objects in a way that supplemental data know what object they belong to added

#17 - 03/24/2022 02:55 PM - Andreas Miiller
- Related to feature request #2584: Show loading information for "Referencing Objects" added

#19 - 04/29/2022 03:00 PM - Katja Luther
- Related to bug #10051: Remaining issues for Referencing Objects View added

#20 - 04/29/2022 03:01 PM - Katja Luther
- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Mdiller
Works fine and open issues are moved to a new ticket.

#21 - 05/06/2022 11:51 AM - Andreas Miiller
- % Done changed from 50 to 100
